#!/usr/local/bin/php
<?php
/**
 * Script to update Whups to cache calculated dates.
 *
 * $Horde: whups/scripts/upgrades/2007-01-16_cache_calculated_dates.php,v 1.2 2007/06/15 15:24:28 chuck Exp $/
 */

@define('AUTH_HANDLER', true);
@define('HORDE_BASE', dirname(__FILE__) . '/../../..');
@define('WHUPS_BASE', HORDE_BASE . '/whups');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();
$cli = &Horde_CLI::singleton();

require_once WHUPS_BASE . '/lib/base.php';
$db = $GLOBALS['whups_driver']->_db;

// Run DML queries to add the new columns.
$db->query('ALTER TABLE whups_tickets ADD COLUMN date_updated INT');
$db->query('ALTER TABLE whups_tickets ADD COLUMN date_assigned INT');
$db->query('ALTER TABLE whups_tickets ADD COLUMN date_resolved INT');

// Pre-calculate some values.
$assigned_states = implode(',', $db->getCol("SELECT state_id FROM whups_states WHERE state_category = 'assigned'"));
$resolved_states = implode(',', $db->getCol("SELECT state_id FROM whups_states WHERE state_category = 'resolved'"));

// Calculate date values for existing tickets.
$ids = $db->getCol('SELECT ticket_id FROM whups_tickets');
foreach ($ids as $ticket) {
    $ticket = (int)$ticket;

    $updated = $db->getOne("SELECT MAX(log_timestamp) FROM whups_logs WHERE ticket_id = $ticket");
    $assigned = $db->getOne("SELECT MAX(log_timestamp) FROM whups_logs WHERE ticket_id = $ticket AND whups_logs.log_type = 'state' AND whups_logs.log_value_num IN ($assigned_states)");
    $resolved = $db->getOne("SELECT MAX(log_timestamp) FROM whups_logs WHERE ticket_id = $ticket AND whups_logs.log_type = 'state' AND whups_logs.log_value_num IN ($resolved_states)");

    if (is_null($updated) && is_null($assigned) && is_null($resolved)) {
        continue;
    }

    $set = array();
    if (!is_null($updated)) {
        $set[] = 'date_updated = ' . $updated;
    }
    if (!is_null($assigned)) {
        $set[] = 'date_assigned = ' . $assigned;
    }
    if (!is_null($resolved)) {
        $set[] = 'date_resolved = ' . $resolved;
    }

    $result = $db->query('UPDATE whups_tickets SET ' . implode(',', $set) . ' WHERE ticket_id = ' . $ticket);
    if (is_a($result, 'PEAR_Error')) {
        var_dump($result);
        exit;
    }
}

echo "Done!\n";
/*
UPDATE whups_tickets
AS T1 SET date_updated = (SELECT MAX(whups_logs.log_timestamp) FROM
whups_logs WHERE whups_logs.ticket_id = T1.ticket_id GROUP BY
whups_logs.ticket_id);

UPDATE whups_tickets AS T1 SET date_assigned = (SELECT
MAX(log_timestamp) FROM whups_logs INNER JOIN whups_states ON
whups_logs.log_type = 'state' AND whups_logs.log_value_num =
whups_states.state_id AND whups_states.state_category = 'assigned'
where whups_logs.ticket_id = T1.ticket_id GROUP BY
whups_logs.ticket_id);

UPDATE whups_tickets AS T1 SET date_resolved = (SELECT
MAX(log_timestamp) FROM whups_logs INNER JOIN whups_states ON
whups_logs.log_type = 'state' AND whups_logs.log_value_num =
whups_states.state_id AND whups_states.state_category = 'resolved'
where whups_logs.ticket_id = T1.ticket_id GROUP BY
whups_logs.ticket_id);
*/
