#!/usr/local/bin/php
<?php
/**
 * $Horde: whups/scripts/upgrades/2007-01-16_query_share_updates.php,v 1.2 2007/06/15 15:22:12 chuck Exp $
 *
 * This is a script to turn saved queries into Horde_Share objects.
 */

@define('AUTH_HANDLER', true);
@define('HORDE_BASE', dirname(__FILE__) . '/../../..');
@define('WHUPS_BASE', HORDE_BASE . '/whups');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();
$cli = &Horde_CLI::singleton();

require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Query.php';

$qManager = new Whups_QueryManager();
$db = $whups_driver->getDb();

// Retrieve the ids of all Whups shares.
$ids = $db->getCol('SELECT datatree_id FROM horde_datatree WHERE group_uid = \'horde.shares.whups\'');

foreach ($ids as $id) {
    $id = (int)$id;

    // Get the query and parameters values for this query.
    $qParams = $db->getAssoc('SELECT attribute_name, attribute_value FROM horde_datatree_attributes WHERE datatree_id = ' . $id . ' AND attribute_name IN (\'parameters\', \'query\')');

    // Insert into the new queries table.
    $sql = 'INSERT INTO whups_queries (query_id, query_parameters, query_object) VALUES (?, ?, ?)';
    $result = $db->query($sql, array($id, $qParams['parameters'], $qParams['query']));
    if (is_a($result, 'PEAR_Error')) {
        var_dump($result);
        exit;
    }

    // Clean up.
    $db->query("DELETE FROM horde_datatree_attributes WHERE datatree_id = $id AND attribute_name = 'query'");
    $db->query("DELETE FROM horde_datatree_attributes WHERE datatree_id = $id AND attribute_name = 'parameters'");
}

// Clean up the currentTicketType parameter that's no longer used.
$db->query("DELETE FROM horde_datatree_attributes WHERE attribute_name = 'currentTicketType'");

echo "Done!\n";
